Strict
Rem
bbdoc: MaxGUI Drivers/CocoaMaxGUI
about:
This Module provides a Cocoa based #MaxGUI driver For Mac OS X.

+Notes
[
* Listbox item tooltips are only supported on Mac OS X 10.4 And higher.
] 

End Rem
Module MaxGUI.CocoaMaxGUI

ModuleInfo "Version: 1.55B"
ModuleInfo "Author: Simon Armstrong, Seb Hollington"
ModuleInfo "License: zlib/libpng"
ModuleInfo "Copyright: Blitz Research Ltd."

ModuleInfo "History: 1.55 Dev"
ModuleInfo "History: Added patch for blank toolbar items in Lion"
ModuleInfo "History: Added UserName$ and ComputerName$ support"
ModuleInfo "History: Stopped EmitCocoaMouseEvent from crashing htmlview"
ModuleInfo "History: 1.54 Release"
ModuleInfo "History: Added RemoveGadgetColor support"
ModuleInfo "History: Removed use of NSPopoupButton for non editable ComboBoxes /topic=91200"
ModuleInfo "History: Reduced ambiguous use of gadget.(arg)name$ /topic=91292"
ModuleInfo "History: 1.53 Release"
ModuleInfo "History: Added GetStatusText() implementation."
ModuleInfo "History: 1.52b Release"
ModuleInfo "History: Fixed several TextArea CTDs."
ModuleInfo "History: 1.51 Release"
ModuleInfo "History: skn3[ac]'s canvas EVENT_MOUSEUP firing fix."
ModuleInfo "History: Added icon support to non-editable ComboBoxes."
ModuleInfo "History: Fixed ComboBox events and implemented non-editable ComboBoxes as NSPopUpButtons."
ModuleInfo "History: 1.50 Release"
ModuleInfo "History: Added LookupColor() method to TCocoaMaxGUIDriver."
ModuleInfo "History: 1.49b Release"
ModuleInfo "History: Fixed EVENT_GADGETLOSTFOCUS interrupting modal drop-down boxes."
ModuleInfo "History: 1.49 Release"
ModuleInfo "History: Fixed SetTextAreaText style problem."
ModuleInfo "History: Added support for thumb-size jumps for scroll-bars."
ModuleInfo "History: 1.48b Release"
ModuleInfo "History: Removed NSString helper functions, instead linking to those in Pub.MacOS."
ModuleInfo "History: Swapped out NSInteger for (int) to avoid compile errors for OS X < 10.5."
ModuleInfo "History: 1.48 Release"
ModuleInfo "History: Fixed mouse and key events for various different gadgets."
ModuleInfo "History: Added support for mouse wheel events."
ModuleInfo "History: Fixed listbox tooltip crash."
ModuleInfo "History: 1.47 Release"
ModuleInfo "History: Fixed DeselectGadgetItem() for ListBox gadgets."
ModuleInfo "History: Applied d-bug's NSScrollbar sizing fix."
ModuleInfo "History: 1.46b Release"
ModuleInfo "History: Swapped out deprecated selectItem() selectors for their selectItemIndexes() counterparts."
ModuleInfo "History: 1.46 Release"
ModuleInfo "History: Fixed panel pixmaps with alpha components."
ModuleInfo "History: Fixed NSColorRequester()."
ModuleInfo "History: 1.45 Release"
ModuleInfo "History: Fixed event generation for canvas gadgets."
ModuleInfo "History: Fixed the CanvasView setAlpha unrecognized selector error."
ModuleInfo "History: 1.44 Release"
ModuleInfo "History: Added explicit removal of NSLinkAttributeName in NSSetStyle()."
ModuleInfo "History: Fixed NSScroller events."
ModuleInfo "History: Swapped out deprecated float selectors for their double-precision counterparts."
ModuleInfo "History: Disabled a few unwanted NSTextView features."
ModuleInfo "History: Fixed progress bar NSState() crash."
ModuleInfo "History: Disabling a panel should now grey out all of its children."
ModuleInfo "History: Fixed a few issues concerning client areas and toolbars."
ModuleInfo "History: Suppressed arrow keys EVENT_GADGETCHAR filter."
ModuleInfo "History: Fixed group panel initial text setting."
ModuleInfo "History: Fixed NSSetPointer through disableCursorRects calls."
ModuleInfo "History: Fixed HTMLView navigation bugs, and added support for both style constants."
ModuleInfo "History: Finished treeview icon support."
ModuleInfo "History: Fixed listview/treeview scrollbar problems."
ModuleInfo "History: Added recursive owner.source handling to EmitCocoaOSEvent."
ModuleInfo "History: PanelViews now extend and use NSBox."
ModuleInfo "History: Added separator for statusbar."
ModuleInfo "History: Attempt to fix PANEL_SUNKENFRAME offset issues."
ModuleInfo "History: LABEL_SUNKENFRAME alignment fix."
ModuleInfo "History: Added TCocoaGuiFont and corresponding Delete() method."
ModuleInfo "History: Attempt to fix button fonts and colors."
ModuleInfo "History: Fixed ClearGadgetItems() for tabber."
ModuleInfo "History: Fixed exception when freeing tabbers."
ModuleInfo "History: 1.43 Release"
ModuleInfo "History: Nodes should now be added to their parent's 'kids' list."
ModuleInfo "History: 1.42 Release"
ModuleInfo "History: Updated NSGadget struct in cocoa.macos.m with recent changes made to MaxGUI TGadget."
ModuleInfo "History: 1.41 Release"
ModuleInfo "History: Fixed clipping issue involving tabs with icons."
ModuleInfo "History: Fixed strange combobox popup list behaviour when appearing over mouse-sensitive gadgets."
ModuleInfo "History: Added EVENT_GADGETMENU for tabbers."
ModuleInfo "History: Added maximum size restraint (26px) for comboboxes to avoid warnings on Leopard."
ModuleInfo "History: Fixed crashes caused by changing NSFont pointers. Use GetFontHandle() to refresh."
ModuleInfo "History: 1.40 Release"
ModuleInfo "History: Added CharX() and CharY() methods for text areas."
ModuleInfo "History: Fixed activation issues when windows are restored from a minimized state."
ModuleInfo "History: Fixed drawing when PANELPIXMAP_FIT2 was used with the PANEL_BORDER flag."
ModuleInfo "History: Fixed hidden child window behaviour (a problem causing the IDE Options window to show when restoring from the dock)."
ModuleInfo "History: 1.39 Release"
ModuleInfo "History: Fixed ACTIVATE_PRINT code for HTMLViews so that the page is printed instead of just the visible region."
ModuleInfo "History: Added hack so that treeviews now have a horizontal scrollbar (if required)."
ModuleInfo "History: Changed child window behaviour so that they are more like child windows in MaxGUI.Win32MaxGUIEx."
ModuleInfo "History: Added several Window checks to determine if it is hidden before proceeding."
ModuleInfo "History: Fixed textcolor memory access error in NSFreeGadget."
ModuleInfo "History: Fixed NSGetText() for HTMLViews and NodeItems."
ModuleInfo "History: Added new BUTTON_PUSH support for radio/checkboxes."
ModuleInfo "History: Fixed FontStyle() so that it now returns values."
ModuleInfo "History: Added LibraryFont() method to TCocoaMaxGUIDriver."
ModuleInfo "History: 1.38 Release"
ModuleInfo "History: Added new Class() method to return a gadget's class for the new GadgetClass() function."
ModuleInfo "History: 1.37 Release"
ModuleInfo "History: Fixed push, ok and cancel buttons returning alternate values from ButtonState() - now returns 0."
ModuleInfo "History: NSState() and NSCheck() tweaked for CHECK_INDETERMINATE."
ModuleInfo "History: Disabled text-areas should no longer allow you to select text."
ModuleInfo "History: Fixed limited tabstops in textareas (now uses setDefaultTabInterval selector)."
ModuleInfo "History: Cleaned up NSSetText(), NSGetText(), NSRedraw() and NSRethink()."
ModuleInfo "History: Added label, button and text-field text colors."
ModuleInfo "History: Added button, text-field and window background colors."
ModuleInfo "History: Added SetSensitivity() and GetSensitivity() methods."
ModuleInfo "History: 1.36 Release"
ModuleInfo "History: Added GadgetText() support for more gadgets (e.g. buttons/menus etc.)."
ModuleInfo "History: Improved handling of text-areas in NSState to avoid crash."
ModuleInfo "History: Swapped tabber icon drawing code (so that it works)."
ModuleInfo "History: Added finishing touch to tool-window support (thanks Brucey)!"
ModuleInfo "History: Fixed TCocoaIconStrip to work with ExtractIconPixmapFromStrip()."
ModuleInfo "History: Tidied up PostCocoaGUIEvent() and added item-extra to tabber events."
ModuleInfo "History: 1.35 Release"
ModuleInfo "History: Added SetMaximumSize method to TNSGadget for possible future implementation of SetMaxWindowSize()."
ModuleInfo "History: Added gadget font support for Buttons, Listboxes, Treeviews and Comboboxes."
ModuleInfo "History: Added a workaround for missing setEnabled responder on textareas."
ModuleInfo "History: Added Koriolis's fix for read-only text-areas in NSGetCursorPos() and NSGetSelectionlength()."
ModuleInfo "History: Added SetGadgetTooltip() support for non-item based gadgets."
ModuleInfo "History: Added Brucey's icon support for buttons and menus using SetGadgetPixmap()."
ModuleInfo "History: Added possible fix for app crashing when popup-menus are created with no text."
ModuleInfo "History: Added possible fix for GadgetDisabled() on certain gadgets."
ModuleInfo "History: Added style hack to accomodate taller buttons."
ModuleInfo "History: 1.34 Release"
ModuleInfo "History: Fixed excessive memory usage by NSPixmapImage"
ModuleInfo "History: 1.33 Release"
ModuleInfo "History: Implemented Brucey's fixes"
ModuleInfo "History: 1.32 Release"
ModuleInfo "History: Fixed to support new SetDataSource fields in TGadget"
ModuleInfo "History: 1.31 Release"
ModuleInfo "History: Fixed TreeView generating extra events"
ModuleInfo "History: Added Seb's fix for button state in EVENT_GADGETACTION data"	
ModuleInfo "History: 1.30 Release"
ModuleInfo "History: Fixed ClearGadgetItems on ListBox generating event"
ModuleInfo "History: Strip windows hotkey shortcut '&' from CreateButton text"
ModuleInfo "History: Fixed FreeGadget childwindow crash"
ModuleInfo "History: Fixed SetPanelPixmap panel,Null"
ModuleInfo "History: 1.29 Release"
ModuleInfo "History: Added fixes for new label code"
ModuleInfo "History: 1.28 Release"
ModuleInfo "History: Optimized ListView tooltip usage"
ModuleInfo "History: Added Brucey's fixes for ListView events"
ModuleInfo "History: Added Brucey's fixes for Label alignment"
ModuleInfo "History: 1.27 Release"
ModuleInfo "History: Bumped version for bizzarro TEXTFORMAT_????? issue"
ModuleInfo "History: 1.26 Release"
ModuleInfo "History: Fixed gadget and extra data fields for EVENT_GADGETMENU node events"
ModuleInfo "History: Added itemx extra object to relevant GADGETACTION events"
ModuleInfo "History: Tweaked bounds checking on textarea CharAt and LineAt"
ModuleInfo "History: 1.25 Release"
ModuleInfo "History: Fixed keyboard filtering bug introduced in 1.23"
ModuleInfo "History: 1.24 Release"
ModuleInfo "History: Bumped to keep in sync with new TMap"
ModuleInfo "History: 1.23 Release"
ModuleInfo "History: Fixed ActiveGadget, Cut, Copy and Paste for TextFields"
ModuleInfo "History: Fixed RequestColor exception with non RGB colors"
ModuleInfo "History: 1.22 Release"
ModuleInfo "History: Premultiply pixels when calling NSPixmap with alpha"
ModuleInfo "History: 1.21 Release"
ModuleInfo "History: Fixed SetMinWindowSize"
ModuleInfo "History: 1.20 Release"
ModuleInfo "History: Fixed WINDOW_CLIENTCOORDS behavior"
ModuleInfo "History: Desktop() client shape now based on [Screen visibleFrame]"
ModuleInfo "History: 1.19 Release"
ModuleInfo "History: Fixed multiple toolbar errors"
ModuleInfo "History: 1.18 Release"
ModuleInfo "History: Added EVENT_GADGETLOSTFOCUS"
ModuleInfo "History: 1.17 Release"
ModuleInfo "History: Rebuilt under 10.3.9"
ModuleInfo "History: 1.16 Release"
ModuleInfo "History: Fixed SetGadgetText to work with menu items courtesy Byteemoz"
ModuleInfo "History: 1.15 Release"
ModuleInfo "History: Fixed Radio Buttons to exclude others in group"
ModuleInfo "History: 1.14 Release"
ModuleInfo "History: Fixed TNSGadget.GetText$() for menu items"
ModuleInfo "History: 1.13 Release"
ModuleInfo "History: NSLoadFont now defaults to systemFontOfSize if font not found"
ModuleInfo "History: 1.12 Release"
ModuleInfo "History: Rebuilt under 10.3.9"
ModuleInfo "History: 1.11 Release"
ModuleInfo "History: Stopped borderless window exceptions (NSDrawWindowBackground)"
ModuleInfo "History: 1.10 Release"
ModuleInfo "History: Added ComboBox support in NSGetText and NSSetText"
ModuleInfo "History: Fixed ListBox gadget action not reporting selection in EventData"
ModuleInfo "History: 1.09 Release"
ModuleInfo "History: Fixed TextView::SetFont (affecting empty TextAreas like MaxIDE output)"
ModuleInfo "History: 1.08 Release"
ModuleInfo "History: Removed NSCompositeCopy so 32bit panelpixmaps blend with window not desktop"
ModuleInfo "History: Fixed DisableGadget for TextFields, Sliders and Menus"
ModuleInfo "History: Stopped TreeViewNode with iconstrip crashing with no icon (icon=-1)"
ModuleInfo "History: Stopped stepper Slider value from wrapping around"
ModuleInfo "History: Fixed TextField to scroll single line correctly"
ModuleInfo "History: Added out of range error checks for TextArea commands"
ModuleInfo "History: 1.07 Release"
ModuleInfo "History: Added support for ActiveGadget() command"
ModuleInfo "History: Fixed FreeGadget TextArea not removing the view "
ModuleInfo "History: 1.06 Release"
ModuleInfo "History: Fixed RedrawGadget with window gadgets"
ModuleInfo "History: Fixed unselecting item in listbox error"
ModuleInfo "History: 1.05 Release"
ModuleInfo "History: Fixed redraw of superview after setframe on view"
ModuleInfo "History: Fixed InsertTreeViewNode ignoring index"
ModuleInfo "History: Fixed SelectTreeViewNode generating multiple events"
ModuleInfo "History: 1.04 Release"
ModuleInfo "History: Fixed NSEnable and NSState STATE_DISABLED issues"
ModuleInfo "History: 1.03 Release"
ModuleInfo "History: Fixed NSRequestFont behavior with null default"
ModuleInfo "History: Fixed Disable on Panel and Canvas NSGadgets"
ModuleInfo "History: 1.02 Release"
ModuleInfo "History: Added Query(QUERY_NSVIEW) and Query(QUERY_NSVIEW_CLIENT)"
ModuleInfo "History: Fixed positioning of PopupWindowMenu"
ModuleInfo "History: Flipped coordinate system for PANEL_VIEW client"
ModuleInfo "History: 1.01 Release"
ModuleInfo "History: Now uses default app menu instead of creating new menu"

?MacOs
Import "cocoagui.bmx"
?
