#ifndef BB_BRL_MAXGUI_H
#define BB_BRL_MAXGUI_H

#include <brl.mod/systemdefault.mod/system.h>

#define ACTIVATE_FOCUS 0
#define ACTIVATE_CUT 1
#define ACTIVATE_COPY 2
#define ACTIVATE_PASTE 3
#define ACTIVATE_MINIMIZE 4
#define ACTIVATE_MAXIMIZE 5
#define ACTIVATE_RESTORE 6
#define ACTIVATE_SELECT 7
#define ACTIVATE_EXPAND 8
#define ACTIVATE_COLLAPSE 9
#define ACTIVATE_BACK 10
#define ACTIVATE_FORWARD 11
#define ACTIVATE_PRINT 12
#define ACTIVATE_REDRAW 13

#define GADGET_DESKTOP 0
#define GADGET_WINDOW 1
#define GADGET_BUTTON 2
#define GADGET_PANEL 3
#define GADGET_TEXTFIELD 4
#define GADGET_TEXTAREA 5
#define GADGET_COMBOBOX 6
#define GADGET_LISTBOX 7
#define GADGET_TOOLBAR 8
#define GADGET_TABBER 9
#define GADGET_TREEVIEW 10
#define GADGET_HTMLVIEW 11
#define GADGET_LABEL 12
#define GADGET_SLIDER 13
#define GADGET_PROGBAR 14
#define GADGET_MENUITEM 15
#define GADGET_NODE 16
#define GADGET_CANVAS 17
#define GADGET_TIMER 18

#define GUICOLOR_WINDOWBG 0
#define GUICOLOR_GADGETBG 1
#define GUICOLOR_GADGETFG 2
#define GUICOLOR_SELECTIONBG 3
#define GUICOLOR_LINKFG 4

#define FONT_NORMAL 0
#define FONT_BOLD 1
#define FONT_ITALIC 2
#define FONT_UNDERLINE 4
#define FONT_STRIKETHROUGH 8

#define CHECK_CLEARED 0
#define CHECK_SELECTED 1
#define CHECK_INDETERMINATE -1

#define STATE_MINIMIZED 1
#define STATE_MAXIMIZED 2
#define STATE_DISABLED 4
#define STATE_HIDDEN 8
#define STATE_SELECTED 16
#define STATE_ACTIVE 32
#define STATE_INDETERMINATE 80

#define GADGETICON_SEPARATOR -2
#define GADGETICON_BLANK -1

#define GADGETITEM_NONE -1
#define GADGETITEM_NORMAL 0
#define GADGETITEM_DEFAULT 1
#define GADGETITEM_TOGGLE 2
#define GADGETITEM_LOCALIZED 4

#define WINDOW_TITLEBAR 1
#define WINDOW_RESIZABLE 2
#define WINDOW_MENU 4
#define WINDOW_STATUS 8
#define WINDOW_TOOL 16
#define WINDOW_CLIENTCOORDS 32
#define WINDOW_HIDDEN 64
#define WINDOW_ACCEPTFILES 128
#define WINDOW_CHILD 256
#define WINDOW_CENTER 512

#define LABEL_LEFT 0
#define LABEL_FRAME 1
#define LABEL_SUNKENFRAME 2
#define LABEL_SEPARATOR 3
#define LABEL_RIGHT 8
#define LABEL_CENTER 16

#define BUTTON_CHECKBOX 2
#define BUTTON_RADIO 3
#define BUTTON_OK 4
#define BUTTON_CANCEL 5
#define BUTTON_PUSH 8

#define PANEL_SUNKEN 1
#define PANEL_RAISED 2
#define PANEL_GROUP 3
#define PANEL_BORDER PANEL_SUNKEN

#define PANEL_ACTIVE 4
#define PANEL_CANVAS 8

#define TEXTAREA_ALL -1

#define TEXTAREA_CHARS 1
#define TEXTAREA_LINES 2

#define TEXTAREA_WORDWRAP 1
#define TEXTAREA_READONLY 2

#define TEXTFIELD_PASSWORD 1

#define TEXTFORMAT_BOLD 1
#define TEXTFORMAT_ITALIC 2
#define TEXTFORMAT_UNDERLINE 4
#define TEXTFORMAT_STRIKETHROUGH 8

#define SLIDER_HORIZONTAL 1
#define SLIDER_VERTICAL 2
#define SLIDER_SCROLLBAR 0
#define SLIDER_TRACKBAR 4
#define SLIDER_STEPPER 8
#define SLIDER_DIAL 12

#define LISTBOX_MULTISELECT 1

#define COMBOBOX_EDITABLE 1

#define TREEVIEW_DRAGNDROP 1

#define HTMLVIEW_NOCONTEXTMENU 1
#define HTMLVIEW_NONAVIGATE 2

#define SENSITIZE_MOUSE 1
#define SENSITIZE_KEYS 2
#define SENSITIZE_ALL 3

#define PANELPIXMAP_TILE 0
#define PANELPIXMAP_CENTER 1
#define PANELPIXMAP_FIT 2
#define PANELPIXMAP_STRETCH 3
#define PANELPIXMAP_FIT2 4

#define GADGETPIXMAP_BACKGROUND 0
#define GADGETPIXMAP_ICON 8
#define GADGETPIXMAP_NOTEXT 16

#define POINTER_DEFAULT 0
#define POINTER_ARROW 1 
#define POINTER_IBEAM 2 
#define POINTER_WAIT 3 
#define POINTER_CROSS 4 
#define POINTER_UPARROW 5 
#define POINTER_SIZENWSE 6 
#define POINTER_SIZENESW 7
#define POINTER_SIZEWE 8 
#define POINTER_SIZENS 9 
#define POINTER_SIZEALL 10 
#define POINTER_NO 11 
#define POINTER_HAND 12 
#define POINTER_APPSTARTING 13 
#define POINTER_HELP 14 

#define QUERY_HWND 1
#define QUERY_HWND_CLIENT 2
#define QUERY_NSVIEW 3
#define QUERY_NSVIEW_CLIENT 4
#define QUERY_FLWIDGET 5
#define QUERY_FLWIDGET_CLIENT 6

#endif
